#%define BuildRoot /tmp/%{name}-%{version}
%define __spec_install_post %{nil}

Summary: A web-based administration interface for Unix systems.
Name: webmin
Version: 1.150
Release: 1AX
Provides: %{name}-%{version}
PreReq: /bin/sh /usr/bin/perl sh-utils perl-Net-SSLeay
Requires: /bin/sh /usr/bin/perl jcode.pl
AutoReq: 0
Copyright: Freeware
Group: System/Tools
Source: http://www.webmin.com/download/%{name}-%{version}.tar.gz

Source100: webmin-miracle-theme.wbt
Source101: webmin-gnome-menu-netscape
Source102: webmin-gnome-menu-mozilla
Source103: webmin_icon.png
Source104: webmin-desktop-link
Source105: webmin-scramble.pl

Patch100: webmin-swat.cgi-miracle.patch
Patch101: webmin-swat_save.cgi-miracle.patch
Patch102: webmin-servers-lib.pl-miracle.patch
Patch103: webmin-majordomo-config-miracle.patch
Patch104: webmin-pam-miracle.patch
Patch105: webmin-setup.sh-miracle.patch
Patch106: webmin-1.150-os_list.txt-miracle.patch
Patch107: webmin-defaulttheme.patch
Patch108: webmin-1.150-delete_modules.patch

BuildRoot: /tmp/%{name}-%{version}
BuildArchitectures: noarch
%description
A web-based administration interface for Unix systems. Using Webmin you can
configure DNS, Samba, NFS, local/remote filesystems and more using your
web browser.

After installation, enter the URL https://localhost:10000/ into your
browser and login as root with your root password.

%prep
%setup -q -a 100

%patch100 -p1
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts*
rm -f mount/openbsd-mounts*
rm -f mount/macos-mounts*
rm -f webmin-gentoo-init
chmod -R og-w .

%install
mkdir -p %{buildroot}/usr/libexec/webmin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}/etc/rc.d/{rc0.d,rc1.d,rc2.d,rc3.d,rc5.d,rc6.d}
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/webmin
cp webmin-daemon %{buildroot}/etc/sysconfig/daemons/webmin
cp webmin-init %{buildroot}/etc/init.d/webmin
cp webmin-pam %{buildroot}/etc/pam.d/webmin
echo rpm >%{buildroot}/usr/libexec/webmin/install-type

# Add Gnome menu
install -m 755 -d %{buildroot}/etc/X11/applnk/System
install -m 755 -d %{buildroot}/etc/X11/starthere
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/applnk/System/webmin.desktop
install -m 644 %{SOURCE102} %{buildroot}/etc/X11/starthere/webmin.desktop
# Add Desktop Icon
install -m 755 -d %{buildroot}/usr/share/pixmaps
install -m 644 %{SOURCE103} %{buildroot}/usr/share/pixmaps/webmin_icon.png
install -m 755 -d %{buildroot}/usr/lib/desktop-links/
install -m 644 %{SOURCE104} %{buildroot}/usr/lib/desktop-links/webmin.links
# Install scramble.pl
install -m 744 %{SOURCE105} %{buildroot}/usr/libexec/webmin/samba/scramble.pl

# remove Japanese message file for file manager
# since java applet can't display japanese correctly.
if [ -e %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc ]; then
        rm -f %{buildroot}/usr/libexec/webmin/file/lang/ja_JP.euc
fi

%clean
#%{rmDESTDIR}
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/libexec/webmin
/etc/sysconfig/daemons/webmin
/etc/init.d/webmin
%config /etc/pam.d/webmin
/etc/X11/applnk/System/webmin.desktop
/etc/X11/starthere/webmin.desktop
/usr/share/pixmaps/webmin_icon.png
/usr/lib/desktop-links/webmin.links

%post
/sbin/chkconfig --add webmin
inetd=`/sbin/service webmin status >/dev/null 2>&1`
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old webmin properly
	if [ "$inetd" = "0" ]; then
		/sbin/service webmin stop >/dev/null 2>&1
	fi
else
	/sbin/chkconfig webmin off
fi

perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = "/tmp/.webmin";

if (!-d \$tmp_dir) {
	mkdir(\$tmp_dir, 0755) || exit 1;
	}
chown(\$<, \$(, \$tmp_dir);
chmod(0755, \$tmp_dir);
@st = lstat(\$tmp_dir);
if (@st && \$st[4] == \$< && (-d _) &&
    (\$st[2] & 0777) == 0755) {
	exit 0;
	}
else {
	exit 1;
	}


EOD

if [ "$?" != "0" ]; then
	echo "Failed to create or check temp files directory /tmp/.webmin"
	exit 1
fi
perl >/tmp/.webmin/$$.check <<EOD;
if (\`cat /etc/asianux-release 2>&1\` =~ /1\\.0/) {
	print "oscheck='Asianux 1.0'\\n"
	}

EOD
. /tmp/.webmin/$$.check
rm -f /tmp/.webmin/$$.check
if [ ! -r /etc/webmin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
fi

config_dir=/etc/webmin
var_dir=/var/webmin
perl=/usr/bin/perl
autoos=3
port=10000
login=root
crypt=x
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
allow=localhost
export config_dir var_dir perl autoos port login crypt host ssl nochown autothird noperlpath nouninstall nostart allow

#save config files made by setup.sh (avoid upgrading config files)
if [ -r $config_dir/config ]; then
        /bin/mv $config_dir/config $config_dir/config.wm_rpmsave
fi
if [ -r $config_dir/miniserv.conf ]; then
        /bin/mv $config_dir/miniserv.conf $config_dir/miniserv.conf.wm_rpmsave
fi

/usr/libexec/webmin/setup.sh >/tmp/.webmin/webmin-setup.out 2>&1
rm -f /var/lock/subsys/webmin
cat >/etc/webmin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Webmin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing webmin RPM .."
	rpm -e --nodeps webmin
	echo "Done!"
fi
EOFF
chmod +x /etc/webmin/uninstall.sh
perl -e 'use Net::SSLeay' >/dev/null 2>/dev/null
if [ "$?" = "0" ]; then
	echo "Webmin install complete. Please login to https://$host:$port/"
else
	echo "Webmin install complete. Please login to http://$host:$port/"
fi
echo "as root with your root password after starting up webmin service."

# Set root acl for security fix
cat >/etc/webmin/root.acl <<EOFF
rpc=0
gedit_mode=0
noconfig=
root=/
gedit=
gedit2=
feedback=2
uedit2=
uedit_mode=0
uedit=
EOFF
chmod 640 /etc/webmin/root.acl
if [ "$1" != 1 ]; then
        # Upgrading the RPM, so start the new webmin properly
        if [ "$inetd" = "0" ]; then
                /sbin/service webmin start >/dev/null 2>&1
        fi
fi

%preun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Run uninstalls and stop the server
		echo "Running uninstall scripts .."
		(cd /usr/libexec/webmin ; WEBMIN_CONFIG=/etc/webmin WEBMIN_VAR=/var/webmin LANG= /usr/libexec/webmin/run-uninstalls.pl)
		/etc/init.d/webmin stop >/dev/null 2>&1
		/sbin/chkconfig --del webmin
		/bin/true
	fi
fi

%postun
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/webmin /etc/webmin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of webmin
		# has taken it's place. Delete the config files
		rm -rf /etc/webmin /var/webmin
	fi
fi

%changelog
* Tue Jun 15 2004 Shiro Yamada <shiro@miraclelinux.com> 1.150-1AX
- upgraded to 1.150

* Tue May 18 2004 Shiro Yamada <shiro@miraclelinux.com> 1.140-2AX
- cleaning up post section
- only start webmin service when it was previously running

* Mon Apr  5 2004 Shiro Yamada <shiro@miraclelinux.com> 1.140-1AX
- Rebuild for Asianux 1.0

* Wed May 28 2003 Yuji Oishi <yoishi@miraclelinux.com>
- delete Vendor tag.
- add RHASML flag setting
- add webmin-gnome-menu-netscape and webmin-gnome-menu-mozilla.
- add webmin_icon.png.
- add webmin-desktop-link.
- add scramble.pl.
- add patch webmin-swat.cgi-miracle.patch.
- add patch webmin-swat_save.cgi-miracle.patch.
- add patch webmin-servers-lib.pl-miracle.patch.
- add patch webmin-majordomo-config-miracle.patch.
- add patch webmin-pam-miracle.patch.
- add "allow=localhost" to forbid remote access in spec file.
- add "export crypt(=x)" in spec file.
- change the description such as "http://localhost:10000" to "https://...." in
  spec file.
- add "sh-utils perl-Net-SSLeay" on PreReq, "jcode.pl" on Requires.
- save config files(config, miniserv.conf) as *.wm_rpmsave when updating
  in spec file
- remove file/lang/ja_JP.euc since java applet can't show Japanese.
- add miraclelinux-release checking line in spec file.
- delete making link in /etc/rc.d/rc*.d, execute chkconfig instead.
- add patch webmin-setup.sh-miracle.patch
- add patch os_list.txt-miracle.patch.
- add patch apache-config-redhat-linux-7.1.patch.
- delete modules which don't work on Miracle Linux
- create root.acl file to fix security problem
